//#define limit_check(x,xmax,fname) ( x > xmax ? (printf "x_max exceeded\n"; printf "x_max exceeded\n" >> fname; abort):())
//#define limit_check (if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; abort}; \
//		             if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; abort}; \
//		             if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; abort}; \
//		             if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; abort}; \
//		             if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; abort}; \
//		             if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; abort})
// gen_com.cmd
// Yongkang Chen, Portland State University
//
// scripts of commands of general use
//
// History of modofication:
// Sept. 28, 2006 original version
// Mar.  14, 2008 Added hessian_M_idx for choosing M 1 or M 2 before Hessian
//
// Predefined commands and variable:
//			vertex_number;
//			go_vug;
//			set_error;
//			do_name; 
//			do_dump;
//			do_dim; 
//			dim_print; 
//			geom_print; 
//			vert_fix; 
//			vert_unfix;
//			hessian_idx;
//                      vert_adj_ind
//                      z_vert_adj_cri
//                      constr_adj_idx
//                      extra_man
// rho, phi, bond are so far three basic variables that can be performed 
// routine computations on. It means the three should appear as 
// parameters in every .fe file where this file is to be read. This
// inconvenience shall be removed in the future in SEI.
//

quiet on

//x_max:=  10*max(vertex, x)
//y_max:=  10*max(vertex, y)
//z_max:=  10*max(vertex, z)
//x_min:=  10*min(vertex, x)
//y_min:=  10*min(vertex, y)
//z_min:=  10*min(vertex, z)

define tenergy real[5]

// histogram commands
lh := histogram(edge where not fixed, length)  // FIT built-in
ah := histogram(facet where not fixed, area)   // FIT built-in

//
// **************************************************************************************
//
		             
script_core := {  printf "Start of script_core\n" >> logname;
                  quiet on; t1:= clock; 
                  it_ind := 1;
                  while it_ind<6 do {{go_vug; 
                                      if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
		                              if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
		                              if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
		                              if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
		                              if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
		                              if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
		                              t (max(edge where not fixed, length)/10)
		                             }5; 
		                             /*do_dump;*/
		                             printf "%s\n", date_and_time;
                                     printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f\n", total_area, total_energy, scale;
                                     printf "%s\t", date_and_time >> logname;
                                     printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f\n", total_area, total_energy, scale>> logname;
		                             tenergy[it_ind] := total_energy; it_ind +=1 
		                            };
                  te_mean := (tenergy[1]+tenergy[2]+tenergy[3]+tenergy[4]+tenergy[5])/5;
                  te_stdev := sqrt(((tenergy[1]-te_mean)^2+(tenergy[2]-te_mean)^2+(tenergy[3]-te_mean)^2+(tenergy[4]-te_mean)^2+(tenergy[5]-te_mean)^2)/5);
		          while (te_stdev > error && tenergy[1] > tenergy[5]) do {
		                tenergy[1]:=tenergy[2];tenergy[2]:=tenergy[3];tenergy[3]:=tenergy[4];tenergy[4]:=tenergy[5];
                        {go_vug; 
                         if constr_adj_idx == 1 then {if min(vertex where not fixed, z) < z_vert_adj_cri then {vert_adj_ind :=1; constr_adj_idx := 0}} ;
		                 if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
		                 if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
		                 if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
		                 if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
		                 if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
		                 if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
		                 t (max(edge where not fixed, length)/10)
		                }5;
		                tenergy[5]:=total_energy; 
                        te_mean := (tenergy[1]+tenergy[2]+tenergy[3]+tenergy[4]+tenergy[5])/5;
                        te_stdev := sqrt(((tenergy[1]-te_mean)^2+(tenergy[2]-te_mean)^2+(tenergy[3]-te_mean)^2+(tenergy[4]-te_mean)^2+(tenergy[5]-te_mean)^2)/5);  
                        if number_iteration imod 15 == 0 then {do_dump};
		                printf "%s\n", date_and_time;
                        printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f\n", total_area, total_energy, scale;
                        printf "%s\t", date_and_time >> logname;
                        printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f\n", total_area, total_energy, scale>> logname;
		                dim_print;
                        if clock-t1 > 1800 then {printf "Time out\n"; printf "Time out\n" >> logname; break}
                      } ;
		          quiet off; extra_man;
		          printf "End of script_core\n" >> logname;
		         }
//               
eigen_core  := {printf "Start of eigen_core\n" >> logname;
                eigenprobe 0; break_after_warning; 
                              do {old_ee:= total_energy; saddle;  
                                  if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
	                              if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
	                              if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
	                              if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
	                              if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
	                              if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
                                  if old_ee == total_energy then break;
				                  eigenprobe 0
                                 } while (eigen_neg>0);
                              break_after_warning off;
                printf "End of eigen_core\n" >> logname;
               }  
//
eigen_print := {printf "Start of eigen_print\n" >> logname;
                break_after_warning; eigenprobe 0; break_after_warning off;
                if eigen_neg == 0 then {ritz(0,2); printf "No negative eigenvalue, lowest eigenvalue: %17.15f\n", last_eigenvalue;
                                        printf "No negative eigenvalue, lowest eigenvalue: %17.15f\n", last_eigenvalue >> logname;
                                        printf "%8.4f\t %17.15f\n", BOND, last_eigenvalue >> eigname;
				       }
                                  else {ritz(-0.1,2); printf "Negative eigenvalues, lowest eigenvalue: %17.15f\n", last_eigenvalue;
                                        printf "Negative eigenvalues, lowest eigenvalue: %17.15f\n", last_eigenvalue >> logname;
                                        printf "%8.4f\t %17.15f\n", BOND, last_eigenvalue >> eigname;
				       };
				printf "End of eigen_print\n" >> logname;
               }
//                 
hessian_core := {printf "Start of hessian_core\n" >> logname;
                 hessian_seek;
                 do {old_e:=total_energy; hessian_seek; if old_e == total_energy then break} 
		         while (last_hessian_scale > 0.01);
		         break_after_warning; eigenprobe 0; break_after_warning off;
		         check_increase on;
		         do {old_e := total_energy; hessian; if (old_e == total_energy) then break; break_after_warning; eigenprobe 0; break_after_warning off}
                 while (eigen_neg ==0);
		         check_increase off;
		         printf "End of hessian_core\n" >> logname;
		}  
//
M1_eigen_study := {printf "Start of M1_eigen_study\n" >> logname;
                   script_core; {if vert_fix_idx == 1 then vert_fix}; 
                   eigen_print; eigen_core; hessian_core; eigen_core; eigen_print; 
                   if eigen_neg >0 then {eigen_core; hessian_core; eigen_core; eigen_print};
                   {if vert_fix_idx == 1 then vert_unfix};
                   printf "End of M1_eigen_study\n" >> logname;
                  }
//                   
M2_eigen_study := {if hessian_M_idx == 1 then {M1_eigen_study}; 
                   if hessian_M_idx == 2 then {M 2; M1_eigen_study; M 1}
                  }
//
script_ini_1  := {printf "Start of script_ini_1\n" >> logname;
                  t_initial := date_and_time; do_name; vertex_number_fixed := count(vertex where not fixed, id);
                  set_error;
		          while (vertex_number_fixed < vertex_number) do
		             {
                      if vertex_number/vertex_number_fixed >= 3.5 then {r; my_re_idx := 0; vertex_number_fixed := count(vertex where not fixed, id)} 
                      else {lr := max(edge where not fixed, length); my_re_idx := 1;  lr := 0.9*lr; 
                            printf "lr = %5.2f\n", lr; printf "lr = %5.2f\n", lr >> logname
                           };
                      script_core; 
   	                  if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
	                  if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
	                  if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
                      lr:= max(edge where not fixed, length);
                      vertex_number_fixed := count(vertex where not fixed, id);
                      /*printf "vertex number where not fixed, %d\n", vertex_number_fixed;*/
                      do_dump;
                     }; 
		          {j 0.05; script_core; do_dump}8;
       		      if hessian_idx == 1 then {{M2_eigen_study}1; do_dump};
		          geom_print;
		          lr:= max(edge where not fixed, length);
                  t_final := date_and_time; 
                  printf "  Number of go_vug iteration: %f\n", number_iteration >> logname;
                  printf "Started at: %s\n",t_initial; 
                  printf "  Ended at: %s\n",t_final;
                  i;  
                  printf "End of script_ini_1\n" >> logname;
                 }
//               
script_ini_2  := {printf "Start of script_ini_2\n" >> logname;
                  t_initial := date_and_time; do_name; lr := max(edge where not fixed, length);
                  set_error;
		          while lr > lr_max do
		             {
                      if lr/lr_max >= 2 then {r; my_re_idx := 1; lr:= max(edge where not fixed, length)} 
                      else {my_re_idx := 1; lr:= 0.9*lr; 
                            printf "lr = %5.2f\n", lr; printf "lr = %5.2f\n", lr >> logname
                           };
                      script_core; 
   	                  if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
	                  if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
	                  if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
	                  if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
                      lr:= max(edge where not fixed, length);
                      do_dump;
                     }; 
		          {j 0.05; script_core; do_dump}8;
       		      if hessian_idx == 1 then {{M2_eigen_study}1; do_dump};
		          geom_print;
		          lr:= max(edge where not fixed, length);
                  t_final := date_and_time; 
                  printf "  Number of go_vug iteration: %f\n", number_iteration >> logname;
                  printf "Started at: %s\n",t_initial; 
                  printf "  Ended at: %s\n",t_final;
                  i;  
                  printf "End of script_ini_2\n" >> logname;
                 }
//               
script_e    := {printf "Start of script_e\n" >> logname;
                t_initial := date_and_time; do_name; set_error; {j 0.05; script_core; do_dump}3; 
                if hessian_idx == 1 then {{M2_eigen_study}1; do_dump};
                printf "Started at: %s\n", t_initial; 
		        printf "  Ended at: %s\n", date_and_time;
		        i;
		        printf "End of script_e\n" >> logname;
	           }
//
converg_idx    := 1   // 1: mesh convergence; 2: deep convergence
conj_grad_idx  := 1  
resolution_idx := 1   // 1: initialization based on vertex number; 2: initialization based on edge length
//
script_converg := {printf "Start of script_converg\n" >> logname;
                   if converg_idx==1 then {lr:= max(edge where not fixed, length); script_core; lr:= max(edge where not fixed, length);
                                           if conj_grad_idx ==1 then {U}; if resolution_idx == 1 then {script_ini_1} else {if resolution_idx == 2 then script_ini_2}; 
                                          }
                   else {script_core; if conj_grad_idx ==1 then {U}; script_e} ;
                   conj_grad_idx += 1;
                   printf "End of script_converg\n" >> logname;
                  }
//               
define bond_value real[1]
bond_value_size := 1;
bond_value[1]:=0
bond_inc := 0.01
bond_fin := 100
bond_array_idx :=1
bond_rout:= {printf "Start of bond_rout\n" >> logname;
             name_idx := 3; t_initial_1 := date_and_time;  
             if bond_value_idx == 1 
                then {bond_ini := bond_value[1]; bond_fin := bond_value[bond_value_size]} 
                else {bond_ini := bond};
             while (bond < bond_fin) do{t_initial_2 := date_and_time; 
			                            if bond_value_idx == 0 then bond += bond_inc else {bond_array_idx += 1; bond := bond_value[bond_array_idx]}; do_name; set_error;
		                                printf "bond: %7.4f, Started at: %s\n", bond, t_initial_2 >> logname; number_iteration := 0; 
			                            {j 0.05; script_core; set_error;
			                             if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
		                                 if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
		                                 if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
		                                 if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
		                                 if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
		                                 if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
                                         do_dump
                                        }8; 
                                        if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
		                                if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
		                                if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
		                                if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
		                                if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
		                                if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
                                        do_dump;
       		                            if hessian_idx == 1 then {{M2_eigen_study}1; do_dump};
		                                geom_print;
                                        printf "Started at: %s\n", t_initial_2;
                                        printf "  Ended at: %s\n", date_and_time;
                                        printf "  Number of go_vug iteration: %f\n", number_iteration >> logname;
                                        printf "  Ended at: %s\n", date_and_time >> logname;
					                   };
             printf "Started at: %s\n", t_initial_1; printf "Ended at: %s\n",date_and_time;
             i;
             printf "End of bond_rout\n" >> logname;
            }

//Bond_rout_eigen := {printf "Start eigenvalue stuffs" >> logname;
//                    name_idx := 3; t_initial_1 := date_and_time;
//                    while (bond > bond_ini) do {local t_initial_2; t_initial_2 := date_and_time;
//                                                if bond_value_idx == 0 then bond += bond_inc else {bond_array_idx += 1; bond := bond_value[bond_array_idx]}; do_name; set_error;
//                                               }
//                   }

quiet off

//phi_inc := 0.01
//phi_fin := 90
//phi_rout    := {name_idx := 2; t_initial_1 := date_and_time;  
//                while (phi < phi_fin) do{t_initial_2 := date_and_time; 
//					 phi += phi_inc; do_name; set_error;
//		                         printf "phi: %7.4f, Started at: %s\n", phi, t_initial_2 >> logname;
//					 {script_core; set_error;
//					 if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
//		                         if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
//		                         if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
//                                         do_dump;}3; 
//                                         if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
//		                         if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
//		                         if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
//		                         if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
//                                         do_dump;
//       		                         if hessian_idx == 1 then {{M2_eigen_study}1; do_dump};
//		                         geom_print;
//                                         printf "Started at: %s\n", t_initial_2;
//                                         printf "  Ended at: %s\n", date_and_time;
//                                         printf "  Ended at: %s\n", date_and_time >> logname;
//					};
//                printf "Started at: %s\n", t_initial_1; printf "Ended at: %s\n",date_and_time;
//                i 
//                }
//

//script_core_o := {quiet on; t1:= clock; go_vug; 
//                do {old_e := total_energy;
//                    {go_vug; 
//		             if max(vertex where not fixed, x) > x_max then {printf "x_max exceeded\n"; printf "x_max exceeded\n" >> logname; break};
//		             if max(vertex where not fixed, y) > y_max then {printf "y_max exceeded\n"; printf "y_max exceeded\n" >> logname; break};
//		             if max(vertex where not fixed, z) > z_max then {printf "z_max exceeded\n"; printf "z_max exceeded\n" >> logname; break};
//		             if min(vertex where not fixed, x) < x_min then {printf "x_min exceeded\n"; printf "x_min exceeded\n" >> logname; break};
//		             if min(vertex where not fixed, y) < y_min then {printf "y_min exceeded\n"; printf "y_min exceeded\n" >> logname; break};
//		             if min(vertex where not fixed, z) < z_min then {printf "z_min exceeded\n"; printf "z_min exceeded\n" >> logname; break};
//		             t (max(edge where not fixed, length)/10)
//		            }5; 
//		            printf "%s\n", date_and_time;
//                  printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f\n", total_area, total_energy, scale;
//                    printf "%s\n", date_and_time >> logname;
//                    printf "total_area: %11.6f  total_energy: %15.10f scale: %9.6f", total_area, total_energy, scale>> logname;
//		            dim_print;
//                    if clock-t1 > 1800 then {printf "Time out\n"; printf "Time out\n" >> logname; break}
//                   }  while (old_e > total_energy && (old_e - total_energy) > error);
//		        quiet off; extra_man
//		       }
